fanotify06 from ubuntu_ltp_syscalls failed

Bug #1833028 reported by Po-Hsu Lin on 2019-06-17
6
This bug affects 1 person
Affects Status Importance Assigned to Milestone
ubuntu-kernel-tests
Undecided
Po-Hsu Lin
linux (Ubuntu)
Undecided
Po-Hsu Lin
Xenial
Undecided
Unassigned
Disco
Undecided
Po-Hsu Lin

Bug Description

== SRU Justification ==
fanotify06 test from ubuntu_ltp_syscalls reported that test #1 for
overlayfs has received more than one expected event:
  <<<test_start>>>
  tag=fanotify06 stime=1560747299
  cmdline="fanotify06"
  contacts=""
  analysis=exit
  <<<test_output>>>
  incrementing stop
  tst_device.c:231: INFO: Using test device LTP_DEV='/dev/loop2'
  tst_mkfs.c:90: INFO: Formatting /dev/loop2 with ext2 opts='' extra opts=''
  mke2fs 1.44.6 (5-Mar-2019)
  tst_test.c:1112: INFO: Timeout per run is 0h 05m 00s
  fanotify06.c:169: INFO: Test #0: Fanotify merge mount mark
  fanotify06.c:147: PASS: group 0 got event: mask 2 pid=1136 fd=15
  ....
  fanotify06.c:230: PASS: group 8 got no event
  fanotify06.c:169: INFO: Test #1: Fanotify merge overlayfs mount mark
  fanotify06.c:208: FAIL: group 0 got more than one event (48 > 24)
  fanotify06.c:208: FAIL: group 1 got more than one event (48 > 24)
  fanotify06.c:208: FAIL: group 2 got more than one event (48 > 24)
  fanotify06.c:220: FAIL: group 3 got event
  fanotify06.c:220: FAIL: group 4 got event
  fanotify06.c:220: FAIL: group 5 got event
  fanotify06.c:220: FAIL: group 6 got event
  fanotify06.c:220: FAIL: group 7 got event
  fanotify06.c:220: FAIL: group 8 got event

  Summary:
  passed 9
  failed 9
  skipped 0
  warnings 0

This duplicated event was generated with operations on files with
"fake" path.

== Fix ==
* d9899030 (ovl: do not generate duplicate fsnotify events for "fake" path)

This patch can be cherry-picked into Disco.

Older kernels are not affected by this issue (without commit d1d04ef8)

== Test ==
Test kernel could be found here:
https://people.canonical.com/~phlin/kernel/lp-1833028-fanotify06-ovl/

Verified on a KVM node, the fanotify06 test will pass with this patched
disco kernel:
 fanotify06.c:169: INFO: Test #1: Fanotify merge overlayfs mount mark
 fanotify06.c:147: PASS: group 0 got event: mask 2 pid=5997 fd=30
 fanotify06.c:147: PASS: group 1 got event: mask 2 pid=5997 fd=30
 fanotify06.c:147: PASS: group 2 got event: mask 2 pid=5997 fd=30
 fanotify06.c:230: PASS: group 3 got no event
 fanotify06.c:230: PASS: group 4 got no event
 fanotify06.c:230: PASS: group 5 got no event
 fanotify06.c:230: PASS: group 6 got no event
 fanotify06.c:230: PASS: group 7 got no event
 fanotify06.c:230: PASS: group 8 got no event

== Regression Potential ==
Low, fix limited to the overlayfs and just corrects the flag behaviour
with "fake" path.

ProblemType: Bug
DistroRelease: Ubuntu 19.04
Package: linux-image-5.0.0-16-generic 5.0.0-16.17
ProcVersionSignature: User Name 5.0.0-16.17-generic 5.0.8
Uname: Linux 5.0.0-16-generic x86_64
AlsaDevices:
 total 0
 crw-rw---- 1 root audio 116, 1 Jun 17 04:37 seq
 crw-rw---- 1 root audio 116, 33 Jun 17 04:37 timer
AplayDevices: Error: [Errno 2] No such file or directory: 'aplay': 'aplay'
ApportVersion: 2.20.10-0ubuntu27
Architecture: amd64
ArecordDevices: Error: [Errno 2] No such file or directory: 'arecord': 'arecord'
AudioDevicesInUse: Error: command ['fuser', '-v', '/dev/snd/seq', '/dev/snd/timer'] failed with exit code 1:
CurrentDmesg:

Date: Mon Jun 17 04:40:18 2019
IwConfig: Error: [Errno 2] No such file or directory: 'iwconfig': 'iwconfig'
Lsusb: Bus 001 Device 001: ID 1d6b:0001 Linux Foundation 1.1 root hub
MachineType: QEMU Standard PC (i440FX + PIIX, 1996)
PciMultimedia:

ProcFB: 0 cirrusdrmfb
ProcKernelCmdLine: BOOT_IMAGE=/boot/vmlinuz-5.0.0-16-generic root=UUID=2a4b0342-a2dd-4feb-b3e2-9644ca1c4a60 ro
RelatedPackageVersions:
 linux-restricted-modules-5.0.0-16-generic N/A
 linux-backports-modules-5.0.0-16-generic N/A
 linux-firmware 1.178.1
RfKill: Error: [Errno 2] No such file or directory: 'rfkill': 'rfkill'
SourcePackage: linux
UpgradeStatus: No upgrade log present (probably fresh install)
dmi.bios.date: 04/01/2014
dmi.bios.vendor: SeaBIOS
dmi.bios.version: Ubuntu-1.8.2-1ubuntu1
dmi.chassis.type: 1
dmi.chassis.vendor: QEMU
dmi.chassis.version: pc-i440fx-xenial
dmi.modalias: dmi:bvnSeaBIOS:bvrUbuntu-1.8.2-1ubuntu1:bd04/01/2014:svnQEMU:pnStandardPC(i440FX+PIIX,1996):pvrpc-i440fx-xenial:cvnQEMU:ct1:cvrpc-i440fx-xenial:
dmi.product.name: Standard PC (i440FX + PIIX, 1996)
dmi.product.version: pc-i440fx-xenial
dmi.sys.vendor: QEMU

Po-Hsu Lin (cypressyew) wrote :
tags: added: 5.0 ubuntu-ltp-syscalls

This bug is missing log files that will aid in diagnosing the problem. While running an Ubuntu kernel (not a mainline or third-party kernel) please enter the following command in a terminal window:

apport-collect 1833028

and then change the status of the bug to 'Confirmed'.

If, due to the nature of the issue you have encountered, you are unable to run this command, please add a comment stating that fact and change the bug status to 'Confirmed'.

This change has been made by an automated script, maintained by the Ubuntu Kernel Team.

Changed in linux (Ubuntu):
status: New → Incomplete
Changed in linux (Ubuntu Disco):
status: New → Incomplete
Po-Hsu Lin (cypressyew) on 2019-06-17
Changed in ubuntu-kernel-tests:
assignee: nobody → Po-Hsu Lin (cypressyew)
status: New → In Progress
Changed in linux (Ubuntu):
assignee: nobody → Po-Hsu Lin (cypressyew)
Changed in linux (Ubuntu Disco):
assignee: nobody → Po-Hsu Lin (cypressyew)
status: Incomplete → In Progress
Changed in linux (Ubuntu):
status: Incomplete → In Progress
Po-Hsu Lin (cypressyew) on 2019-06-17
description: updated
Po-Hsu Lin (cypressyew) on 2019-06-17
description: updated
Sean Feole (sfeole) on 2019-06-17
tags: added: sru-20190603
Changed in linux (Ubuntu Disco):
status: In Progress → Fix Committed

This bug is awaiting verification that the kernel in -proposed solves the problem. Please test the kernel and update this bug with the results. If the problem is solved, change the tag 'verification-needed-disco' to 'verification-done-disco'. If the problem still exists, change the tag 'verification-needed-disco' to 'verification-failed-disco'.

If verification is not done by 5 working days from today, this fix will be dropped from the source code, and this bug will be closed.

See https://wiki.ubuntu.com/Testing/EnableProposed for documentation how to enable and use -proposed. Thank you!

tags: added: verification-needed-disco
Po-Hsu Lin (cypressyew) wrote :

Passed with Disco amd64:
 startup='Fri Jul 5 03:52:26 2019'
 tst_device.c:231: INFO: Using test device LTP_DEV='/dev/loop2'
 tst_mkfs.c:90: INFO: Formatting /dev/loop2 with ext2 opts='' extra opts=''
 mke2fs 1.44.6 (5-Mar-2019)
 tst_test.c:1100: INFO: Timeout per run is 0h 05m 00s
 fanotify06.c:169: INFO: Test #0: Fanotify merge mount mark
 fanotify06.c:147: PASS: group 0 got event: mask 2 pid=14414 fd=30
 fanotify06.c:147: PASS: group 1 got event: mask 2 pid=14414 fd=30
 fanotify06.c:147: PASS: group 2 got event: mask 2 pid=14414 fd=30
 fanotify06.c:230: PASS: group 3 got no event
 fanotify06.c:230: PASS: group 4 got no event
 fanotify06.c:230: PASS: group 5 got no event
 fanotify06.c:230: PASS: group 6 got no event
 fanotify06.c:230: PASS: group 7 got no event
 fanotify06.c:230: PASS: group 8 got no event
 fanotify06.c:169: INFO: Test #1: Fanotify merge overlayfs mount mark
 fanotify06.c:147: PASS: group 0 got event: mask 2 pid=14414 fd=30
 fanotify06.c:147: PASS: group 1 got event: mask 2 pid=14414 fd=30
 fanotify06.c:147: PASS: group 2 got event: mask 2 pid=14414 fd=30
 fanotify06.c:230: PASS: group 3 got no event
 fanotify06.c:230: PASS: group 4 got no event
 fanotify06.c:230: PASS: group 5 got no event
 fanotify06.c:230: PASS: group 6 got no event
 fanotify06.c:230: PASS: group 7 got no event
 fanotify06.c:230: PASS: group 8 got no event

 Summary:
 passed 18
 failed 0
 skipped 0
 warnings 0

tags: added: verification-done-disco
removed: verification-needed-disco
Po-Hsu Lin (cypressyew) wrote :

Checked with the recent SRU test result, this is failing with Xenial, it needs to be investigated.

tags: added: xenial
Launchpad Janitor (janitor) wrote :
Download full text (57.5 KiB)

This bug was fixed in the package linux - 5.0.0-21.22

---------------
linux (5.0.0-21.22) disco; urgency=medium

  * linux: 5.0.0-21.22 -proposed tracker (LP: #1834902)

  * Disco update: 5.0.15 upstream stable release (LP: #1834529)
    - net: stmmac: Use bfsize1 in ndesc_init_rx_desc
    - Drivers: hv: vmbus: Remove the undesired put_cpu_ptr() in hv_synic_cleanup()
    - ubsan: Fix nasty -Wbuiltin-declaration-mismatch GCC-9 warnings
    - staging: greybus: power_supply: fix prop-descriptor request size
    - staging: wilc1000: Avoid GFP_KERNEL allocation from atomic context.
    - staging: most: cdev: fix chrdev_region leak in mod_exit
    - staging: most: sound: pass correct device when creating a sound card
    - ASoC: tlv320aic3x: fix reset gpio reference counting
    - ASoC: hdmi-codec: fix S/PDIF DAI
    - ASoC: stm32: sai: fix iec958 controls indexation
    - ASoC: stm32: sai: fix exposed capabilities in spdif mode
    - ASoC: stm32: sai: fix race condition in irq handler
    - ASoC:soc-pcm:fix a codec fixup issue in TDM case
    - ASoC:hdac_hda:use correct format to setup hda codec
    - ASoC:intel:skl:fix a simultaneous playback & capture issue on hda platform
    - ASoC: dpcm: prevent snd_soc_dpcm use after free
    - ASoC: nau8824: fix the issue of the widget with prefix name
    - ASoC: nau8810: fix the issue of widget with prefixed name
    - ASoC: samsung: odroid: Fix clock configuration for 44100 sample rate
    - ASoC: rt5682: Check JD status when system resume
    - ASoC: rt5682: fix jack type detection issue
    - ASoC: rt5682: recording has no sound after booting
    - ASoC: wm_adsp: Add locking to wm_adsp2_bus_error
    - clk: meson-gxbb: round the vdec dividers to closest
    - ASoC: stm32: dfsdm: manage multiple prepare
    - ASoC: stm32: dfsdm: fix debugfs warnings on entry creation
    - ASoC: cs4270: Set auto-increment bit for register writes
    - ASoC: dapm: Fix NULL pointer dereference in snd_soc_dapm_free_kcontrol
    - drm/omap: hdmi4_cec: Fix CEC clock handling for PM
    - IB/hfi1: Clear the IOWAIT pending bits when QP is put into error state
    - IB/hfi1: Eliminate opcode tests on mr deref
    - IB/hfi1: Fix the allocation of RSM table
    - MIPS: KGDB: fix kgdb support for SMP platforms.
    - ASoC: tlv320aic32x4: Fix Common Pins
    - drm/mediatek: Fix an error code in mtk_hdmi_dt_parse_pdata()
    - perf/x86/intel: Fix handling of wakeup_events for multi-entry PEBS
    - perf/x86/intel: Initialize TFA MSR
    - linux/kernel.h: Use parentheses around argument in u64_to_user_ptr()
    - iov_iter: Fix build error without CONFIG_CRYPTO
    - xtensa: fix initialization of pt_regs::syscall in start_thread
    - ASoC: rockchip: pdm: fix regmap_ops hang issue
    - drm/amdkfd: Add picasso pci id
    - drm/amdgpu: Adjust IB test timeout for XGMI configuration
    - drm/amdgpu: amdgpu_device_recover_vram always failed if only one node in
      shadow_list
    - drm/amd/display: fix cursor black issue
    - ASoC: cs35l35: Disable regulators on driver removal
    - objtool: Add rewind_stack_do_exit() to the noreturn list
    - slab: fix a crash by reading /proc/slab_allocators
    - drm/sun4i: tcon top: Fix NULL/inv...

Changed in linux (Ubuntu Disco):
status: Fix Committed → Fix Released
Po-Hsu Lin (cypressyew) wrote :

With Xenial, the ovl fakepath test is failing:

fanotify06.c:169: INFO: Test #0: Fanotify merge mount mark
fanotify06.c:147: PASS: group 0 got event: mask 2 pid=1446 fd=15
fanotify06.c:147: PASS: group 1 got event: mask 2 pid=1446 fd=15
fanotify06.c:147: PASS: group 2 got event: mask 2 pid=1446 fd=15
fanotify06.c:230: PASS: group 3 got no event
fanotify06.c:230: PASS: group 4 got no event
fanotify06.c:230: PASS: group 5 got no event
fanotify06.c:230: PASS: group 6 got no event
fanotify06.c:230: PASS: group 7 got no event
fanotify06.c:230: PASS: group 8 got no event
fanotify06.c:169: INFO: Test #1: Fanotify merge overlayfs mount mark
fanotify06.c:147: PASS: group 0 got event: mask 2 pid=1446 fd=15
fanotify06.c:147: PASS: group 1 got event: mask 2 pid=1446 fd=15
fanotify06.c:147: PASS: group 2 got event: mask 2 pid=1446 fd=15
fanotify06.c:220: FAIL: group 3 got event
fanotify06.c:220: FAIL: group 4 got event
fanotify06.c:220: FAIL: group 5 got event
fanotify06.c:220: FAIL: group 6 got event
fanotify06.c:220: FAIL: group 7 got event
fanotify06.c:220: FAIL: group 8 got event

Summary:
passed 12
failed 6
skipped 0
warnings 0

However, the open_with_fake_path() was first introduced in commit d1d04ef8 in file fs/overlayfs/file.c, this does not exist in Xenial.

Po-Hsu Lin (cypressyew) on 2019-07-25
tags: added: 4.4
tags: added: sru-20190701
Po-Hsu Lin (cypressyew) on 2019-08-05
tags: added: sru-20190722
To post a comment you must log in.
This report contains Public information  Edit
Everyone can see this information.

Other bug subscribers